     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.app.tidbits;

     import java.io.IOException;
     import java.util.Date;

     import com.orbs.open1.mit.net.mail.SMTPMail;
// Get rid of SMTPTest.
     import com.orbs.open1.mit.net.mail.SMTPTest;
     import com.orbs.open1.mit.servlet.Mission;

     /*********************************************************************
     * <P>
     * @author                                                        
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-01-25
     *********************************************************************/

     public class  TidBitsMission extends Mission {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private static final String  SUBJECT = "TidBits";

     private static final String  MESSAGE
       = "\nhttp://webservername:8080/servlet/tidbitsservlet";

     static final long  serialVersionUID = 1L;

     private String   username;
     private String   usermail;
     private boolean  mail     = false;
     private int      height   = 10;

     //////////////////////////////////////////////////////////////////////
     // Constructor Methods
     //////////////////////////////////////////////////////////////////////
        
     public  TidBitsMission (
       String  username,
       String  usermail,
       Date    start ) {
     //////////////////////////////////////////////////////////////////////
       this.username = username;
       this.usermail = usermail;
       setNextRun ( start );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  getUsername ( ) { return username; }
     public String  getUsermail ( ) { return usermail; }

     public boolean  getMail ( ) { return mail; }
     public int      getHeight ( ) { return height; }
     public void     setMail ( boolean  mail ) { this.mail = mail; }
     public void     setHeight ( int  height ) { this.height = height; }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public synchronized void  run ( ) {
     //////////////////////////////////////////////////////////////////////
       if ( !isRunDue ( ) ) return;
       if ( !mail ) return;
       setLastRun ( new Date ( ) );
       try {
         SMTPMail.send (
           SMTPTest.DEFAULT_MAIL_SERVER_HOST,
           SMTPTest.DEFAULT_ADDRESS_FROM,
           usermail, SUBJECT, MESSAGE );
       } catch ( Exception  e ) { setNextRun ( null ); }
       while ( isRunDue ( ) ) {
         Date  nextRun = getNextRun ( );
         if ( nextRun == null ) break;
         nextRun.setDate ( nextRun.getDate ( ) + 1 );
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
