     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.app.tidbits;

     import java.io.*;
     import java.util.*;

     /*********************************************************************
     * <P>
     * @author                                                        
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-10-05
     *********************************************************************/

     public class  TidBitsRecord implements Serializable {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     static final long  serialVersionUID = 1L;

     private String  name;
     private String  user;
     private String  mail;
// These should store user ids, not user names!
     private Vector  yea_users = new Vector ( );
     private Vector  nay_users = new Vector ( );

     //////////////////////////////////////////////////////////////////////
     // Constructor Methods
     //////////////////////////////////////////////////////////////////////
        
     public  TidBitsRecord (
       String  name, String  user, String  mail ) {
     //////////////////////////////////////////////////////////////////////
       this.name = name;
       this.user = user;
       this.mail = mail;
     }

     public  TidBitsRecord ( String  name ) {
     //////////////////////////////////////////////////////////////////////
       this ( name, null, null );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  getName ( ) { return name; }
     public String  getUser ( ) { return user; }
     public String  getMail ( ) { return mail; }
     public long    getYeas ( ) { return yea_users.size ( ); }
     public long    getNays ( ) { return nay_users.size ( ); }

     public double  getScore ( ) {
     //////////////////////////////////////////////////////////////////////
       long  nays = getNays ( );
       if ( nays == 0 ) return 1.0;
       return getYeas ( ) / ( double ) nays;
     }

     public void  unvote ( String  username ) {
     //////////////////////////////////////////////////////////////////////
       nay_users.removeElement ( username );
       yea_users.removeElement ( username );
     }

     public void  vote ( String  username, boolean  yea_nay ) {
     //////////////////////////////////////////////////////////////////////
       if ( yea_nay ) voteYea ( username ); else voteNay ( username );
     }

     public void  voteYea ( String  username ) {
     //////////////////////////////////////////////////////////////////////
       unvote ( username );
       yea_users.addElement ( username );
     }

     public void  voteNay ( String  username ) {
     //////////////////////////////////////////////////////////////////////
       unvote ( username );
       nay_users.addElement ( username );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
