     //////////////////////////////////////////////////////////////////////
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.io;

     import java.io.*;

     /*********************************************************************
     * 
     * Static library methods to load/save a Serializable object from/to
     * a file.
     * 
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-09-18
     *********************************************************************/

     public final class  SerializableLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  SerializableLib ( ) { }

     /*********************************************************************
     * Tests the serialization and deserialization methods.
     *********************************************************************/
     public static void  main ( String [ ]  args )
       throws Exception
     //////////////////////////////////////////////////////////////////////
     {
       String  filename = args [ 0 ];

       Serializable  serializable = args [ 1 ];

       save ( filename, serializable );

       serializable = load ( filename );

       System.out.println ( serializable );
     }

     public static Serializable  load ( String  filename )
       throws FileNotFoundException, IOException, ClassNotFoundException
     //////////////////////////////////////////////////////////////////////
     {
       File  file = new File ( filename );

       FileInputStream  in = new FileInputStream ( file );

       ObjectInputStream  s = new ObjectInputStream ( in );

       Serializable  serializable = ( Serializable ) s.readObject ( );

       s.close ( );

       in.close ( );

       return serializable;
     }

     public static void  save (
       String  filename, Serializable  serializable )
       throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       save ( filename, serializable, true );
     }

     public static void  save (
       String  filename, Serializable  serializable, boolean  makeDirs )
       throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       if ( makeDirs ) FileLib.makeParents ( filename );

       FileOutputStream  f = new FileOutputStream ( filename );

       ObjectOutputStream  s = new ObjectOutputStream ( f );

       s.writeObject ( serializable );

       s.flush ( );

       s.close ( );

       f.close ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
