     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.client.reactor.ChatReactorEntity",
     // created 2000-01-16.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 2000 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.client.reactor;

     import com.orbs.open1.mpl.j1d1.util.queue.*;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.client.*;

     /*********************************************************************
     * <P>
     *
     * @version
     *   2000-04-28
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     *********************************************************************/

     public final class  ChatReactorEntity implements ChatReactor
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatClient  chatClient;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatReactorEntity ( ChatClient  chatClient )
     //////////////////////////////////////////////////////////////////////
     {
       if ( chatClient == null )
       {
         throw new IllegalArgumentException ( "null" );
       }

       this.chatClient = chatClient;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage [ ]  react ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       ChatEntityID  chatEntityID
         = new ChatEntityID ( chatMessage.getValues ( ) [ 0 ] );

//     chatClient.setChatEntityID ( chatEntityID );

       chatClient.display ( "Received ChatEntityID:  " + chatEntityID );

       chatClient.display ( "Requesting environment load..." );

       return new ChatMessage [ ] {
         new ChatMessage (
           ChatMessage.CODE_REQUEST_LOAD,
           chatEntityID,
           null ) };
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
