     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.command.ChatCommandView",
     // created 2000-01-23.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 2000 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.server.command;

     import java.awt.Point;
     import java.util.*;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.server.*;

     /*********************************************************************
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-01-23
     *********************************************************************/

     public final class  ChatCommandView implements ChatCommand
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatModel  chatModel;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatCommandView ( ChatModel  chatModel )
     //////////////////////////////////////////////////////////////////////
     {
       this.chatModel = chatModel;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage  process ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       String [ ]  values = chatMessage.getValues ( );

       int  x      = Integer.parseInt ( values [ 0 ] );

       int  y      = Integer.parseInt ( values [ 1 ] );

       int  width  = Integer.parseInt ( values [ 2 ] );

       int  height = Integer.parseInt ( values [ 3 ] );

       chatModel.setView (
         chatMessage.getChatEntityID ( ), x, y, width, height );

       return null;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
