     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.app.tag3d.Tag3D",
     // created 1999-02-07.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.tag3d;

     /*********************************************************************
     *
     * Tag3D main application class.
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1999-02-07
     *********************************************************************/

     public final class  Tag3D implements Tag3DConstants
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public static void  main ( String [ ]  args )
     //////////////////////////////////////////////////////////////////////
     {
       if ( System.getSecurityManager ( ) == null )
       {
         System.setSecurityManager ( new Tag3DSecurityManager ( ) );
       }

       Tag3DWorld  tag3DWorld = Tag3DWorld.build ( );

       String  id = ( args.length > 0 ? args [ 0 ] : DEFAULT_ID );

       Tag3DStateManager  tag3DStateManager
         = new Tag3DStateManager ( tag3DWorld, id );

       tag3DWorld.canvas3D.addKeyListener (
         new Tag3DKeyListener (
           DELTA_ROTATION,
           DELTA_TRANSLATION,
           id,
           tag3DStateManager,
           tag3DWorld.viewTransformGroup ) );

       new Tag3DFrame ( 0, 0, 256, 256, id, tag3DWorld.canvas3D ).show ( );

       if ( args.length > 1 ) tag3DStateManager.setupRemote ( args [ 1 ] );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
