     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.vaft.util.broadcast.Broadcast",
     // created 1999-04-05.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.vaft.util.broadcast;

     import java.util.*;

     /*********************************************************************
     * <P>
     * Used to broadcast BroadcastEvent objects to BroadcastListener
     * objects.
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-04-05
     *********************************************************************/

     public class  Broadcast implements Broadcaster
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private Broadcaster  broadcaster;
     private Vector       listeners;

     //////////////////////////////////////////////////////////////////////
     // Constructor method
     //////////////////////////////////////////////////////////////////////

     public  Broadcast ( Broadcaster  broadcaster )
     //////////////////////////////////////////////////////////////////////
     {
       this.broadcaster = broadcaster;
       listeners = new Vector ( );
     }

     //////////////////////////////////////////////////////////////////////
     // Access methods
     //////////////////////////////////////////////////////////////////////

     public Broadcaster  getBroadcaster ( ) { return broadcaster; }
     public Vector       getListeners   ( ) { return listeners  ; }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  getBroadcastName ( )
     //////////////////////////////////////////////////////////////////////
     {
       return broadcaster.toString ( );
     }

     public synchronized boolean  addBroadcastListener (
       BroadcastListener  bl )
     //////////////////////////////////////////////////////////////////////
     {
       if ( listeners.contains ( bl ) ) return false;
       listeners.addElement ( bl );
       return true;
     }

     public boolean  removeBroadcastListener ( BroadcastListener  bl )
     //////////////////////////////////////////////////////////////////////
     {
       return listeners.removeElement ( bl );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public void  broadcast ( String  announcement )
     //////////////////////////////////////////////////////////////////////
     {
       broadcast ( new BroadcastEvent ( broadcaster, announcement ) );
     }

     protected synchronized void  broadcast ( BroadcastEvent  be )
     //////////////////////////////////////////////////////////////////////
     {
       Enumeration  e = listeners.elements ( );
       while ( e.hasMoreElements ( ) )
       {
         BroadcastListener  broadcastListener
           = ( BroadcastListener ) e.nextElement ( );
         broadcastListener.broadcastSent ( be );
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
