     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.util.id.LongID"
     // created 1999-12-19.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 2000 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.util.id;

     /*********************************************************************
     * An ID implementation that uses a Long object as its value.
     *
     * <P>
     *
     * @see
     *   ID
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   2000-04-20
     *********************************************************************/

     public class  LongID implements ID
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private static final long  serialVersionUID = 1L;

     private Long  l;

     //////////////////////////////////////////////////////////////////////
     // Constructor methods
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * @throws IllegalArgumentException
     *
     *   If argument is null.
     *********************************************************************/
     public  LongID ( Long  l )
     //////////////////////////////////////////////////////////////////////
     {
       if ( l == null )
       {
         throw new IllegalArgumentException ( "null l" );
       }

       this.l = l;
     }

     public  LongID ( long  l )
     //////////////////////////////////////////////////////////////////////
     {
       this ( new Long ( l ) );
     }

     public  LongID ( String  s )
     //////////////////////////////////////////////////////////////////////
     {
       this ( Long.valueOf ( s ) );
     }

     //////////////////////////////////////////////////////////////////////
     // Accessor method
     //////////////////////////////////////////////////////////////////////

     public Long  getL ( ) { return l; }

     //////////////////////////////////////////////////////////////////////
     // ID interface methods
     //////////////////////////////////////////////////////////////////////

     public Object  clone ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         return super.clone ( );
       }
       catch ( CloneNotSupportedException  ex )
       {
         // This will never happen.

         throw new RuntimeException ( );
       }
     }

     public boolean  equals ( Object  other )
     //////////////////////////////////////////////////////////////////////
     {
       if ( ( other == null )
         || !getClass ( ).equals ( other.getClass ( ) ) )

       {
         return false;
       }

       return l.equals ( ( ( LongID ) other ).l );
     }

     public int  hashCode ( )
     //////////////////////////////////////////////////////////////////////
     {
       return l.hashCode ( );
     }

     public String  toString ( )
     //////////////////////////////////////////////////////////////////////
     {
       return l.toString ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
