     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.math.MathLib",
     // created 1998-12-27.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.math;

     /*********************************************************************
     * A collection of constants and static methods to supplement
     * java.lang.Math.
     *
     * @version
     *   1998-12-27
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public final class  MathLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public static final double  GOLDEN_RATIO = 1.618033988749894848204586;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * Returns +1 if positive, -1 if negative, otherwise 0.
     *********************************************************************/
     public static byte  signum ( long  l )
     //////////////////////////////////////////////////////////////////////
     {
       return ( byte ) ( l > 0 ? 1 : ( l < 0 ? -1 : 0 ) );
     }

     /*********************************************************************
     * Also known as the "logistic function".
     *********************************************************************/
     public static double  sigmoid ( double  a )
     //////////////////////////////////////////////////////////////////////
     {
       return 1.0 / ( 1.0 + Math.exp ( -a ) );
     }

     /*********************************************************************
     * hyperbolic tangent = 2 * sigmoid ( 2 * a ) - 1
     *********************************************************************/
     public static double  tanh ( double  a )
     //////////////////////////////////////////////////////////////////////
     {
       return 2.0 * sigmoid ( 2.0 * a ) - 1.0;
     }

     /*********************************************************************
     * The derivative with respect to the argument.
     *********************************************************************/
     public static double  sigmoidDerivative ( double  a )
     //////////////////////////////////////////////////////////////////////
     {
       double  y = sigmoid ( a );
       return y * ( 1.0 - y );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private  MathLib ( ) { }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
