     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.media.j3d.Transform3DState",
     // created 1999-02-06.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.media.j3d;

     import java.io.Serializable;

     import javax.media.j3d.Transform3D;

     import com.orbs.open1.mpl.util.state.State;
     import com.orbs.open1.mpl.util.state.StateLib;

     /*********************************************************************
     *
     * A State object that carries Transform3D data.
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1999-02-06
     *********************************************************************/

     public class  Transform3DState implements State, Serializable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private static final long  serialVersionUID = 1L;

     private Object      key;
     private double [ ]  transform;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  Transform3DState (
       Object       key,
       Transform3D  transform3D )
     //////////////////////////////////////////////////////////////////////
     {
       this.key = key;
       transform = new double [ 16 ];
       transform3D.get ( transform );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public Object  getKey ( ) { return key; }

     public void  getTransform3D ( Transform3D  transform3D )
     //////////////////////////////////////////////////////////////////////
     {
       transform3D.set ( transform );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     /*********************************************************************
     * Returns true if the classes and State keys are equal.
     *********************************************************************/
     public boolean  equals ( Object  other )
     //////////////////////////////////////////////////////////////////////
     {
       return StateLib.equals ( this, other );
     }

     /*********************************************************************
     * Returns the hash code of the State key.
     *********************************************************************/
     public int  hashCode ( )
     //////////////////////////////////////////////////////////////////////
     {
       return StateLib.hashCode ( this );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
