     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.role.actor.ActorRemote",
     // created 1998-04-26.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.role.actor;

     import java.rmi.*;

     /*********************************************************************
     * A semantic interface for bootstrapping the exchange of semantic
     * interfaces between remote objects.
     *
     * <P>
     *
     * The semantic definition for this interface is available at:<BR>
     * <A HREF="http://www.alumni.caltech.edu/~croft/research/agent/role/">
     * http://www.alumni.caltech.edu/~croft/research/agent/role/</A>
     *
     * <P>
     *
     * This differs from the com.orbs.pub.agent.role.Actor semantic
     * interface in the following ways:
     *
     * <OL>
     * <LI> the interface extend java.rmi.Remote
     * <LI> the method throws java.rmi.RemoteException
     * </OL>
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1998-04-26
     *********************************************************************/

     public interface  ActorRemote extends Remote
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public abstract String [ ]  getRolesRemote ( ) throws RemoteException;
     
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
