     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.util.cache.URLContentAccessor"
     // created 1999-04-24.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.util.cache;

     import java.io.*;
     import java.net.*;

     /*********************************************************************
     * A ContentAccessor that accesses the content via a URL.
     *
     * @version
     *   1999-04-24
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public class  URLContentAccessor
       implements ContentAccessor, Serializable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private static final long  serialVersionUID = 1L;

     protected String  urlName;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  URLContentAccessor ( String  urlName )
       throws MalformedURLException
     //////////////////////////////////////////////////////////////////////
     {
       this.urlName = urlName;


       // Test to see if valid URL.
       new URL ( urlName );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  getURLName ( ) { return urlName; }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public InputStream  getInputStream ( ) throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       URL  url = null;

       try
       {
         url = new URL ( urlName );
       }
       catch ( MalformedURLException  ex )
       {
         return null;
       }

       URLConnection  urlConnection = url.openConnection ( );

       if ( urlConnection instanceof HttpURLConnection )
       {
         HttpURLConnection  httpURLConnection
           = ( HttpURLConnection ) urlConnection;

         if ( httpURLConnection.getResponseCode ( )
           != HttpURLConnection.HTTP_OK )
         {
           return null;
         }
       }

       return urlConnection.getInputStream ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
