     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.util.state.StateListenerAmbassador",
     // created 1998-12-05.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.util.state;

     import java.io.Serializable;
     import java.rmi.*;

     import com.orbs.open1.mpl.lang.ex.*;

     /*********************************************************************
     *
     * An ambassador proxy for StateListenerRemote objects.
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1998-12-05
     *********************************************************************/

     public class  StateListenerAmbassador
       implements StateListener, Serializable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private StateListenerRemote  stateListenerRemote;

     private transient ExceptionListener  exceptionListener;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  StateListenerAmbassador (
       StateListenerRemote  stateListenerRemote,
       ExceptionListener    exceptionListener )
     //////////////////////////////////////////////////////////////////////
     {
       this.stateListenerRemote = stateListenerRemote;
       this.exceptionListener   = exceptionListener;
     }

     public  StateListenerAmbassador (
       StateListenerRemote  stateListenerRemote )
     //////////////////////////////////////////////////////////////////////
     {
       this ( stateListenerRemote, new PrintExceptionListener ( ) );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public void  stateListen ( State  state )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         stateListenerRemote.stateListen ( state );
       }
       catch ( Exception  ex )
       {
         if ( exceptionListener != null )
         {
           exceptionListener.threwException ( this, ex );
         }
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
